#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const auth_oauth_device_1 = require("@octokit/auth-oauth-device");
const rest_1 = require("@octokit/rest");
const readline = __importStar(require("readline"));
const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout,
});
rl.setPrompt(":");
let octokit;
let content = "";
let newlines = 2;
const resetInput = () => {
    content = "";
    newlines = 2;
};
const question = (prompt) => {
    return new Promise((resolve, reject) => {
        rl.question(prompt, resolve);
    });
};
const readLines = () => {
    rl.on("line", (input) => __awaiter(void 0, void 0, void 0, function* () {
        // line feeds can appear in copied code
        input = input.replace("\r", "");
        // Append the line to the code content
        content += input + "\n";
        if (input === "") {
            newlines--;
        }
        else {
            newlines = 2;
        }
        // Once 2 blank lines have been entered
        if (newlines === 0) {
            const fileName = yield question("Filename: ");
            content = content.trim();
            if (!fileName) {
                // Clear the current content
                resetInput();
                prompt();
                return;
            }
            // Create a public gist
            const response = yield octokit.rest.gists.create({
                public: true,
                files: {
                    [fileName]: {
                        content,
                    },
                },
            });
            // Output the link to the gist
            console.log(response.data.html_url);
            resetInput();
        }
        rl.prompt();
    }));
};
const auth = (0, auth_oauth_device_1.createOAuthDeviceAuth)({
    clientType: "oauth-app",
    clientId: "4bec01f9c58a6489e727",
    scopes: ["gist"],
    onVerification(verification) {
        console.log("Open %s", verification.verification_uri);
        console.log("Enter code: %s", verification.user_code);
    },
});
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const tokenAuthentication = yield auth({
            type: "oauth",
        });
        console.log("Authenticated.");
        octokit = new rest_1.Octokit({
            auth: tokenAuthentication.token,
        });
        rl.prompt();
        readLines();
    });
}
main();
